/* IMPORT */
import ShoSho from 'shosho';
import { FORMAT } from './constants.js';
/* MAIN */
const castArray = (value) => {
    return Array.isArray(value) ? value : [value];
};
const memoize = (fn) => {
    const cache = new Map();
    return (arg) => {
        const resultCached = cache.get(arg);
        if (typeof resultCached !== 'undefined' || cache.has(arg))
            return resultCached;
        const result = fn(arg);
        cache.set(arg, result);
        return result;
    };
};
const shortcut2id = memoize((shortcut) => {
    return ShoSho.format(shortcut, FORMAT);
});
/* EXPORT */
export { castArray, shortcut2id };
